<?php

namespace Drupal\media_entity_remote_google_photos\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\link\Plugin\Field\FieldFormatter\LinkFormatter;

/**
 * remote Google photos URL field formatter.
 *
 * @FieldFormatter(
 *   id = "rgp_url_formatter",
 *   label = @Translation("Image with metatags"),
 *   description = @Translation("Display the remote Google photos along with its associated metatags."),
 *   field_types = {
 *     "rgp_url"
 *   }
 * )
 */
class RemoteGooglePhotosUrlFormatter extends LinkFormatter {

  /**
   * @inheritDoc
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = parent::viewElements($items, $langcode);
    $values = $items->getValue();

    foreach ($elements as $delta => $entity) {
      $elements[$delta] = [
        '#type' => 'markup',
        '#markup' => "<img src='{$values[$delta]['uri']}' alt='{$values[$delta]['title']}'>",
        '#allowed_tags' => ['img'],
      ];
    }

    return $elements;
  }

}
